class ViewPreviewForm
Same name and namespace in other branches
- 11.x core/modules/views_ui/src/ViewPreviewForm.php \Drupal\views_ui\ViewPreviewForm
- 10 core/modules/views_ui/src/ViewPreviewForm.php \Drupal\views_ui\ViewPreviewForm
- 9 core/modules/views_ui/src/ViewPreviewForm.php \Drupal\views_ui\ViewPreviewForm
- 8.9.x core/modules/views_ui/src/ViewPreviewForm.php \Drupal\views_ui\ViewPreviewForm
Form controller for the Views preview form.
@internal
Hierarchy
- class \Drupal\Core\Form\FormBase implements \Drupal\Core\Form\FormInterface, \Drupal\Core\DependencyInjection\ContainerInjectionInterface uses \Drupal\Core\DependencyInjection\AutowireTrait, \Drupal\Core\DependencyInjection\DependencySerializationTrait, \Drupal\Core\Htmx\HtmxRequestInfoTrait, \Drupal\Core\Logger\LoggerChannelTrait, \Drupal\Core\Messenger\MessengerTrait, \Drupal\Core\Routing\RedirectDestinationTrait, \Drupal\Core\StringTranslation\StringTranslationTrait
- class \Drupal\Core\Entity\EntityForm implements \Drupal\Core\Entity\EntityFormInterface extends \Drupal\Core\Form\FormBase
- class \Drupal\views_ui\ViewFormBase extends \Drupal\Core\Entity\EntityForm
- class \Drupal\views_ui\ViewPreviewForm implements \Drupal\Core\Form\WorkspaceSafeFormInterface extends \Drupal\views_ui\ViewFormBase
- class \Drupal\views_ui\ViewFormBase extends \Drupal\Core\Entity\EntityForm
- class \Drupal\Core\Entity\EntityForm implements \Drupal\Core\Entity\EntityFormInterface extends \Drupal\Core\Form\FormBase
Expanded class hierarchy of ViewPreviewForm
File
-
core/
modules/ views_ui/ src/ ViewPreviewForm.php, line 14
Namespace
Drupal\views_uiView source
class ViewPreviewForm extends ViewFormBase implements WorkspaceSafeFormInterface {
/**
* {@inheritdoc}
*/
public function form(array $form, FormStateInterface $form_state) {
$view = $this->entity;
$form['#prefix'] = '<div id="views-preview-wrapper" class="views-preview-wrapper views-admin clearfix">';
$form['#suffix'] = '</div>';
$form['#id'] = 'views-ui-preview-form';
$form_state->disableCache();
$form['controls']['#attributes'] = [
'class' => [
'clearfix',
],
];
$form['controls']['title'] = [
'#prefix' => '<h2 class="view-preview-form__title">',
'#markup' => $this->t('Preview'),
'#suffix' => '</h2>',
];
// Add a checkbox controlling whether or not this display auto-previews.
$form['controls']['live_preview'] = [
'#type' => 'checkbox',
'#id' => 'edit-displays-live-preview',
'#title' => $this->t('Auto preview'),
'#default_value' => \Drupal::config('views.settings')->get('ui.always_live_preview'),
];
// Add the arguments textfield.
$form['controls']['view_args'] = [
'#type' => 'textfield',
'#title' => $this->t('Preview with contextual filters:'),
'#description' => $this->t('Separate contextual filter values with a "/". For example, %example.', [
'%example' => '40/12/10',
]),
'#id' => 'preview-args',
];
$args = [];
if ($form_state->getValue('view_args', '') !== '') {
$args = explode('/', $form_state->getValue('view_args'));
}
$user_input = $form_state->getUserInput();
if ($form_state->get('show_preview') || !empty($user_input['js'])) {
$form['preview'] = [
'#weight' => 110,
'#theme_wrappers' => [
'container',
],
'#attributes' => [
'id' => 'views-live-preview',
'class' => [
'views-live-preview',
],
],
'preview' => $view->renderPreview($this->displayID, $args),
];
}
$uri = $view->toUrl('preview-form');
$uri->setRouteParameter('display_id', $this->displayID);
$form['#action'] = $uri->toString();
return $form;
}
/**
* {@inheritdoc}
*/
protected function actions(array $form, FormStateInterface $form_state) {
$view = $this->entity;
return [
'#attributes' => [
'id' => 'preview-submit-wrapper',
'class' => [
'preview-submit-wrapper',
],
],
'button' => [
'#type' => 'submit',
'#value' => $this->t('Update preview'),
'#attributes' => [
'class' => [
'arguments-preview',
],
],
'#submit' => [
'::submitPreview',
],
'#id' => 'preview-submit',
'#ajax' => [
'url' => Url::fromRoute('entity.view.preview_form', [
'view' => $view->id(),
'display_id' => $this->displayID,
]),
'wrapper' => 'views-preview-wrapper',
'event' => 'click',
'progress' => [
'type' => 'fullscreen',
],
'method' => 'replaceWith',
'disable-refocus' => TRUE,
],
],
];
}
/**
* Form submission handler for the Preview button.
*/
public function submitPreview($form, FormStateInterface $form_state) {
$form_state->set('show_preview', TRUE);
$form_state->setRebuild();
}
}
Members
| Title Sort descending | Modifiers | Object type | Summary | Overriden Title | Overrides |
|---|---|---|---|---|---|
| AutowiredInstanceTrait::createInstanceAutowired | public static | function | Instantiates a new instance of the implementing class using autowiring. | ||
| AutowiredInstanceTrait::getAutowireArguments | private static | function | Resolves arguments for a method using autowiring. | ||
| AutowireTrait::create | public static | function | Instantiates a new instance of the implementing class using autowiring. | 130 | |
| DependencySerializationTrait::$_entityStorages | protected | property | An array of entity type IDs keyed by the property name of their storages. | ||
| DependencySerializationTrait::$_serviceIds | protected | property | An array of service IDs keyed by property name used for serialization. | ||
| DependencySerializationTrait::__sleep | public | function | 2 | ||
| DependencySerializationTrait::__wakeup | public | function | 2 | ||
| EntityForm::$entity | protected | property | The entity being used by this form. | 10 | |
| EntityForm::$entityTypeManager | protected | property | The entity type manager. | 3 | |
| EntityForm::$moduleHandler | protected | property | The module handler service. | 3 | |
| EntityForm::$operation | protected | property | The name of the current operation. | ||
| EntityForm::actionsElement | protected | function | Returns the action form element for the current entity form. | ||
| EntityForm::afterBuild | public | function | Form element #after_build callback: Updates the entity with submitted data. | 1 | |
| EntityForm::buildEntity | public | function | Overrides EntityFormInterface::buildEntity | 5 | |
| EntityForm::copyFormValuesToEntity | protected | function | Copies top-level form values to entity properties. | 12 | |
| EntityForm::getBaseFormId | public | function | Overrides BaseFormIdInterface::getBaseFormId | 3 | |
| EntityForm::getCallableFromDefinition | protected | function | Gets a callable from a string or array definition if possible. | ||
| EntityForm::getEntity | public | function | Overrides EntityFormInterface::getEntity | ||
| EntityForm::getEntityFromRouteMatch | public | function | Overrides EntityFormInterface::getEntityFromRouteMatch | 3 | |
| EntityForm::getFormId | public | function | Overrides FormInterface::getFormId | 14 | |
| EntityForm::getOperation | public | function | Overrides EntityFormInterface::getOperation | ||
| EntityForm::prepareInvokeAll | protected | function | Invokes the specified prepare hook variant. | ||
| EntityForm::processForm | public | function | Process callback: assigns weights and hides extra fields. | ||
| EntityForm::save | public | function | Overrides EntityFormInterface::save | 45 | |
| EntityForm::setEntity | public | function | Overrides EntityFormInterface::setEntity | ||
| EntityForm::setEntityTypeManager | public | function | Overrides EntityFormInterface::setEntityTypeManager | ||
| EntityForm::setModuleHandler | public | function | Overrides EntityFormInterface::setModuleHandler | ||
| EntityForm::setOperation | public | function | Overrides EntityFormInterface::setOperation | ||
| EntityForm::submitForm | public | function | This is the default entity object builder function. It is called before any other submit handler to build the new entity object to be used by the following submit handlers. At this point of the form workflow the entity is validated and the form state… |
Overrides FormInterface::submitForm | 21 |
| FormBase::$configFactory | protected | property | The config factory. | 1 | |
| FormBase::$requestStack | protected | property | The request stack. | 1 | |
| FormBase::$routeMatch | protected | property | The route match. | ||
| FormBase::config | protected | function | Retrieves a configuration object. | ||
| FormBase::configFactory | protected | function | Gets the config factory for this form. | 1 | |
| FormBase::container | private | function | Returns the service container. | ||
| FormBase::currentUser | protected | function | Gets the current user. | 2 | |
| FormBase::getRequest | protected | function | Gets the request object. | Overrides HtmxRequestInfoTrait::getRequest | |
| FormBase::getRouteMatch | protected | function | Gets the route match. | ||
| FormBase::logger | protected | function | Gets the logger for a specific channel. | ||
| FormBase::redirect | protected | function | Returns a redirect response object for the specified route. | ||
| FormBase::resetConfigFactory | public | function | Resets the configuration factory. | ||
| FormBase::setConfigFactory | public | function | Sets the config factory for this form. | ||
| FormBase::setRequestStack | public | function | Sets the request stack object to use. | ||
| FormBase::validateForm | public | function | Overrides FormInterface::validateForm | 54 | |
| HtmxRequestInfoTrait::getHtmxCurrentUrl | protected | function | Retrieves the URL of the requesting page from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxPrompt | protected | function | Retrieves the prompt from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTarget | protected | function | Retrieves the target identifier from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTrigger | protected | function | Retrieves the trigger identifier from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTriggerName | protected | function | Retrieves the trigger name from an HTMX request header. | ||
| HtmxRequestInfoTrait::isHtmxBoosted | protected | function | Determines if the request is boosted by HTMX. | ||
| HtmxRequestInfoTrait::isHtmxHistoryRestoration | protected | function | Determines if if the request is for history restoration. | ||
| HtmxRequestInfoTrait::isHtmxRequest | protected | function | Determines if the request is sent by HTMX. | ||
| LoggerChannelTrait::$loggerFactory | protected | property | The logger channel factory service. | ||
| LoggerChannelTrait::getLogger | protected | function | Gets the logger for a specific channel. | ||
| LoggerChannelTrait::setLoggerFactory | public | function | Injects the logger channel factory. | ||
| MessengerTrait::$messenger | protected | property | The messenger. | 25 | |
| MessengerTrait::messenger | public | function | Gets the messenger. | 25 | |
| MessengerTrait::setMessenger | public | function | Sets the messenger. | ||
| RedirectDestinationTrait::$redirectDestination | protected | property | The redirect destination service. | 2 | |
| RedirectDestinationTrait::getDestinationArray | protected | function | Prepares a 'destination' URL query parameter for use with \Drupal\Core\Url. | ||
| RedirectDestinationTrait::getRedirectDestination | protected | function | Returns the redirect destination service. | ||
| RedirectDestinationTrait::setRedirectDestination | public | function | Sets the redirect destination service. | ||
| StringTranslationTrait::$stringTranslation | protected | property | The string translation service. | 3 | |
| StringTranslationTrait::formatPlural | protected | function | Formats a string containing a count of items. | ||
| StringTranslationTrait::getNumberOfPlurals | protected | function | Returns the number of plurals supported by a given language. | ||
| StringTranslationTrait::getStringTranslation | protected | function | Gets the string translation service. | ||
| StringTranslationTrait::setStringTranslation | public | function | Sets the string translation service to use. | 2 | |
| StringTranslationTrait::t | protected | function | Translates a string to the current language or to a given language. | 1 | |
| ViewFormBase::$displayID | protected | property | The name of the display used by the form. | ||
| ViewFormBase::buildForm | public | function | Overrides EntityForm::buildForm | ||
| ViewFormBase::getDisplayLabel | public | function | Placeholder function for overriding $display['display_title']. | ||
| ViewFormBase::getDisplayTabs | public | function | Adds tabs for navigating across Displays when editing a View. | ||
| ViewFormBase::init | public | function | Overrides EntityForm::init | ||
| ViewFormBase::isDefaultDisplayShown | public | function | Returns whether or not the default display should have its own tab on edit. | ||
| ViewFormBase::prepareEntity | protected | function | Overrides EntityForm::prepareEntity | 2 | |
| ViewPreviewForm::actions | protected | function | Overrides EntityForm::actions | ||
| ViewPreviewForm::form | public | function | Overrides EntityForm::form | ||
| ViewPreviewForm::submitPreview | public | function | Form submission handler for the Preview button. |
Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.